//+------------------------------------------------------------------+
//|                                             TradeMonutor-T01.mq4 |
//|                        Copyright  2008, HomeSoft - Tartan Corp. |
//|                                             spiky@home.eltel.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, HomeSoft - Tartan Corp."
#property link      "spiky@home.eltel.net"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Black
#property indicator_color4 Black
#property indicator_color5 Black
#property indicator_color6 Black
#property indicator_color7 Black

extern int           per     = 14;    //    
extern double        tmin    = 30;    //      
extern double        tmax    = 100;   //      
extern double        th4     = 10;    //      4
extern double        dh      = 10;    //             
extern double        Tent    = 10;     //     
extern double        Tout    = 19;    //    
extern int           mBar    = 150;   //        
//====================================================================
string parnul="TIMEOUT";
string simb="";
string shrift="System";
string csh="Arial Black";
double p,p1,p2,p3,p4,p5,p6,p7,h0,h1,deh,candh4,candd1,trend,osum,otkat;
double EUBuff[],GUBuff[],UJBuff[],UCBuff[],EJBuff[],GJBuff[],EGBuff[],maxc,minc;
int    csize=10,size=14;
int    cnt,vpar,para,sig,pr,kb,ks,tblok;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    p1=MarketInfo("EURUSD",MODE_POINT);
    p2=MarketInfo("GBPUSD",MODE_POINT);
    p3=MarketInfo("USDCHF",MODE_POINT);
    p4=MarketInfo("USDJPY",MODE_POINT); 
    p5=MarketInfo("EURJPY",MODE_POINT);
    p6=MarketInfo("GBPJPY",MODE_POINT);
    p7=MarketInfo("EURGBP",MODE_POINT);
    vpar=7;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
       maxc=0;minc=0;
  for (cnt=0;cnt<=vpar+1;cnt++)
   {
        para=para+1; 
switch (para)
   {     
 case 1:simb="EURUSD";sig=0;p=p1;break;

 case 2:simb="GBPUSD";sig=0;p=p2;break; 
    
 case 3:simb="USDCHF";sig=0;p=p3;break;    
    
 case 4:simb="USDJPY";sig=0;p=p4;break;      
    
 case 5:simb="EURJPY";sig=0;p=p5;break; 
    
 case 6:simb="GBPJPY";sig=0;p=p6;break;
    
 case 7:simb="EURGBP";sig=0;p=p7;break;  
   
default:simb=parnul;para=0;break;     
     }
     
    if (p>0.0002) pr=2; else pr=4;
        h0=iCustom(simb,1440,"HP",mBar,per,0,0);     
        h1=iCustom(simb,1440,"HP",mBar,per,0,1);
        deh=NormalizeDouble(((h0-h1)/p),1);
        candh4=(iClose(simb,240,0)-iOpen(simb,240,0))/p;
        candd1=(iClose(simb,1440,0)-iOpen(simb,1440,0))/p;
        trend=(iClose(simb,1440,0)-iClose(simb,1440,1))/p;     

    if (trend>=tmin && candd1>tmin && candd1<tmax && candh4>=th4 && deh>=dh)                   sig=1;
    if (trend<=-tmin && candd1<-tmin && candd1>-tmax && candh4<=-th4 && deh<=-dh)              sig=-1;
    if (((trend<tmin || trend>tmax) && trend>0) || ((trend>-tmin || trend<-tmax) && trend<=0)) sig=0;     
     
 
    if (para!=0)                           
     {  
      
    if (sig==1)
        ObjectSetText("Smb",simb , csize, csh, Lime);
    if (sig==-1)
        ObjectSetText("Smb",simb , csize, csh, Red);
    if (sig==0)
        ObjectSetText("Smb",simb , csize, csh, Gold);          
        
        ObjectSet("Smb", OBJPROP_XDISTANCE, 1066);
        ObjectSet("Smb", OBJPROP_YDISTANCE, 30);
        ObjectCreate("Smb", OBJ_LABEL, 0,1066,20);
     }       
  else                                     
     {  
        ObjectSetText("Smb","TIMEOUT", csize, csh, Gold);  
        ObjectSet("Smb", OBJPROP_XDISTANCE, 1066);
        ObjectSet("Smb", OBJPROP_YDISTANCE, 30);
        ObjectCreate("Smb", OBJ_LABEL, 0,1066,20);
     }
                                                      
     
    if (para!=0)
     {                                             
    if (iClose(simb,60,0)>iOpen(simb,60,0))     {ObjectSetText("CH1","H1", csize, csh, Lime);}  
    if (iClose(simb,60,0)<iOpen(simb,60,0))     {ObjectSetText("CH1","H1", csize, csh, Red);}
    if (iClose(simb,60,0)==iOpen(simb,60,0))    {ObjectSetText("CH1","H1", csize, csh, Magenta);}
                                                 ObjectSet("CH1", OBJPROP_XDISTANCE, 1055);
                                                 ObjectSet("CH1", OBJPROP_YDISTANCE, 50);
                                                 ObjectCreate("CH1", OBJ_LABEL, 0,1055,20);
                 
    if (iClose(simb,240,0)>iOpen(simb,240,0))   {ObjectSetText("CH4","H4", csize, csh, Lime);}  
    if (iClose(simb,240,0)<iOpen(simb,240,0))   {ObjectSetText("CH4","H4", csize, csh, Red);}
    if (iClose(simb,240,0)==iOpen(simb,240,0))  {ObjectSetText("CH4","H4", csize, csh, Magenta);}
                                                 ObjectSet("CH4", OBJPROP_XDISTANCE, 1088);
                                                 ObjectSet("CH4", OBJPROP_YDISTANCE, 50);
                                                 ObjectCreate("CH4", OBJ_LABEL, 0,1088,20);                 
       
    if (iClose(simb,1440,0)>iOpen(simb,1440,0)) {ObjectSetText("CD1","D1", csize, csh, Lime);}  
    if (iClose(simb,1440,0)<iOpen(simb,1440,0)) {ObjectSetText("CD1","D1", csize, csh, Red);}
    if (iClose(simb,1440,0)==iOpen(simb,1440,0)){ObjectSetText("CD1","D1", csize, csh, Magenta);}
                                                 ObjectSet("CD1", OBJPROP_XDISTANCE, 1121);
                                                 ObjectSet("CD1", OBJPROP_YDISTANCE, 50);
                                                 ObjectCreate("CD1", OBJ_LABEL, 0,1121,20);  

     }
  else
     {   
                                                 ObjectSetText("CH1","", csize, csh, Black);
                                                 ObjectSet("CH1", OBJPROP_XDISTANCE, 1055);
                                                 ObjectSet("CH1", OBJPROP_YDISTANCE, 50);
                                                 ObjectCreate("CH1", OBJ_LABEL, 0,1055,20);       
                                              
                                                 ObjectSetText("CH4","", csize, csh, Black);    
                                                 ObjectSet("CH4", OBJPROP_XDISTANCE, 1088);
                                                 ObjectSet("CH4", OBJPROP_YDISTANCE, 50);
                                                 ObjectCreate("CH4", OBJ_LABEL, 0,1088,20);           
                                              
                                                 ObjectSetText("CD1","", csize, csh, Black);
                                                 ObjectSet("CD1", OBJPROP_XDISTANCE, 1121);
                                                 ObjectSet("CD1", OBJPROP_YDISTANCE, 50);
                                                 ObjectCreate("CD1", OBJ_LABEL, 0,1121,20);     
     }                                                                                  
    
    if (simb=="EURUSD")
     { 
    if (candd1>tmin)
     {  ObjectSetText("EURUSDtr", "EURUSD= "+DoubleToStr(candd1,1), size, shrift, Lime);}
    if (candd1<-tmin) 
     {  ObjectSetText("EURUSDtr", "EURUSD= "+DoubleToStr(candd1,1), size, shrift, Red);}
    if (candd1<=tmin && candd1>=-tmin) 
     {  ObjectSetText("EURUSDtr", "EURUSD= "+DoubleToStr(candd1,1), size, shrift, Blue);}
        ObjectSet("EURUSDtr", OBJPROP_XDISTANCE, 1050);
        ObjectSet("EURUSDtr", OBJPROP_YDISTANCE, 70);
        ObjectCreate("EURUSDtr", OBJ_LABEL, 0,1050,20); 
        EUBuff[0]=candd1;
    if (candd1>0 && candd1>maxc) maxc=candd1;
    if (candd1<0 && candd1<minc) minc=candd1;      
     }   

    if (simb=="GBPUSD")
     {        
    if (candd1>tmin)
     {  ObjectSetText("GBPUSDtr", "GBPUSD= "+DoubleToStr(candd1,1), size, shrift, Lime);}
    if (candd1<-tmin) 
     {  ObjectSetText("GBPUSDtr", "GBPUSD= "+DoubleToStr(candd1,1), size, shrift, Red);}
    if (candd1<=tmin && candd1>=-tmin) 
     {  ObjectSetText("GBPUSDtr", "GBPUSD= "+DoubleToStr(candd1,1), size, shrift, Blue);}
        ObjectSet("GBPUSDtr", OBJPROP_XDISTANCE, 1050);
        ObjectSet("GBPUSDtr", OBJPROP_YDISTANCE, 90);
        ObjectCreate("GBPUSDtr", OBJ_LABEL, 0,1050,20); 
        GUBuff[0]=candd1;
    if (candd1>0 && candd1>maxc) maxc=candd1;
    if (candd1<0 && candd1<minc) minc=candd1;        
     }
     
    if (simb=="USDCHF")
     {         
    if (candd1>tmin)
     {  ObjectSetText("USDCHFtr", "USDCHF= "+DoubleToStr(candd1,1), size, shrift, Lime);}
    if (candd1<-tmin) 
     {  ObjectSetText("USDCHFtr", "USDCHF= "+DoubleToStr(candd1,1), size, shrift, Red);}
    if (candd1<=tmin && candd1>=-tmin)
     {  ObjectSetText("USDCHFtr", "USDCHF= "+DoubleToStr(candd1,1), size, shrift, Blue);}
        ObjectSet("USDCHFtr", OBJPROP_XDISTANCE, 1050);
        ObjectSet("USDCHFtr", OBJPROP_YDISTANCE, 110);
        ObjectCreate("USDCHFtr", OBJ_LABEL, 0,1050,20);  
        UCBuff[0]=candd1;
    if (candd1>0 && candd1>maxc) maxc=candd1;
    if (candd1<0 && candd1<minc) minc=candd1;        
     }
         
    if (simb=="USDJPY")
     {                   
    if (candd1>tmin)
     {  ObjectSetText("USDJPYtr", "USDJPY= "+DoubleToStr(candd1,1), size, shrift, Lime);}
    if (candd1<-tmin) 
     {  ObjectSetText("USDJPYtr", "USDJPY= "+DoubleToStr(candd1,1), size, shrift, Red);}
    if (candd1<=tmin && candd1>=-tmin) 
     {  ObjectSetText("USDJPYtr", "USDJPY= "+DoubleToStr(candd1,1), size, shrift, Blue);}
        ObjectSet("USDJPYtr", OBJPROP_XDISTANCE, 1050);
        ObjectSet("USDJPYtr", OBJPROP_YDISTANCE, 130);
        ObjectCreate("USDJPYtr", OBJ_LABEL, 0,1050,20);
        UJBuff[0]=candd1;
    if (candd1>0 && candd1>maxc) maxc=candd1;
    if (candd1<0 && candd1<minc) minc=candd1;        
     }
     
    if (simb=="EURJPY")
     {         
    if (candd1>tmin)
     {  ObjectSetText("EURJPYtr", "EURJPY= "+DoubleToStr(candd1,1), size, shrift, Lime);}
    if (candd1<-tmin) 
     {  ObjectSetText("EURJPYtr", "EURJPY= "+DoubleToStr(candd1,1), size, shrift, Red);}
    if (candd1<=tmin && candd1>=-tmin)
     {  ObjectSetText("EURJPYtr", "EURJPY= "+DoubleToStr(candd1,1), size, shrift, Blue);}
        ObjectSet("EURJPYtr", OBJPROP_XDISTANCE, 1050);
        ObjectSet("EURJPYtr", OBJPROP_YDISTANCE, 150);
        ObjectCreate("EURJPYtr", OBJ_LABEL, 0,1050,20);     
        EJBuff[0]=candd1;
    if (candd1>0 && candd1>maxc) maxc=candd1;
    if (candd1<0 && candd1<minc) minc=candd1;        
     }
        
    if (simb=="GBPJPY")
     {         
    if (candd1>tmin)
     {  ObjectSetText("GBPJPYtr", "GBPJPY= "+DoubleToStr(candd1,1), size, shrift, Lime);}
    if (candd1<-tmin) 
     {  ObjectSetText("GBPJPYtr", "GBPJPY= "+DoubleToStr(candd1,1), size, shrift, Red);}
    if (candd1<=tmin && candd1>=-tmin) 
     {  ObjectSetText("GBPJPYtr", "GBPJPY= "+DoubleToStr(candd1,1), size, shrift, Blue);}
        ObjectSet("GBPJPYtr", OBJPROP_XDISTANCE, 1050);
        ObjectSet("GBPJPYtr", OBJPROP_YDISTANCE, 170);
        ObjectCreate("GBPJPYtr", OBJ_LABEL, 0,1050,20);  
        GJBuff[0]=candd1; 
    if (candd1>0 && candd1>maxc) maxc=candd1;
    if (candd1<0 && candd1<minc) minc=candd1;          
     }
         
    if (simb=="EURGBP")
     {        
    if (candd1>tmin)
     {  ObjectSetText("EURGBPtr", "EURGBP= "+DoubleToStr(candd1,1), size, shrift, Lime);}
    if (candd1<-tmin) 
     {  ObjectSetText("EURGBPtr", "EURGBP= "+DoubleToStr(candd1,1), size, shrift, Red);}
    if (candd1<=tmin && candd1>=-tmin) 
     {  ObjectSetText("EURGBPtr", "EURGBP= "+DoubleToStr(candd1,1), size, shrift, Blue);}
        ObjectSet("EURGBPtr", OBJPROP_XDISTANCE, 1050);
        ObjectSet("EURGBPtr", OBJPROP_YDISTANCE, 190);
        ObjectCreate("EURGBPtr", OBJ_LABEL, 0,1050,20);
        EGBuff[0]=candd1; 
    if (candd1>0 && candd1>maxc) maxc=candd1;
    if (candd1<0 && candd1<minc) minc=candd1;        
     }   
        
        ObjectSetText("LineDt", "=============", size, shrift, Gold);
        ObjectSet("LineDt", OBJPROP_XDISTANCE, 1045);
        ObjectSet("LineDt", OBJPROP_YDISTANCE, 205);
        ObjectCreate("LineDt", OBJ_LABEL, 0,1045,20);         

    if (otkat>30) tblok=1;    
    if (tblok==1 || Hour()<Tent || Hour()>=Tout) ObjectSetText("Trd", "Trade:  Close",csize, csh, Red);
    if (tblok==0 && Hour()>=Tent && Hour()<Tout) ObjectSetText("Trd", "Trade:   Open",csize, csh, Lime);
        ObjectSet("Trd", OBJPROP_XDISTANCE, 1052);
        ObjectSet("Trd", OBJPROP_YDISTANCE, 220);
        ObjectCreate("Trd", OBJ_LABEL, 0,1052,20);   
        
    }//      
    
    
//----
   return(0);
  }
//+------------------------------------------------------------------+